import array
ring_buffer_size = 32
ring_buffer = array.array('L', range(ring_buffer_size))
target_buffer = array.array('L', (0x80000000 for _ in range(ring_buffer_size*4)))

import time
#time.sleep_ms(10) #just to ensure the buffers are allocated correctly

from machine import mem32
import uctypes
import dma_dev

dma_channel0 = dma_dev.DMA_CHANNELS[0]
dma = dma_dev.DMA_DEVICE

dma.CH0_DBG_CTDREQ = 1 #reconfigure DREQ Handshake
dma.CHAN_ABORT = 0x01 #0x01: abort chanel 0 transfer

dma_channel0.READ_ADDR_REG = uctypes.addressof(ring_buffer)
dma_channel0.WRITE_ADDR_REG = uctypes.addressof(target_buffer)
dma_channel0.TRANS_COUNT_REG = ring_buffer_size*4
dma.TIMER0 = 0x00010001

dma_channel0.CTRL_TRIG_REG = 0
dma_channel0.CTRL_TRIG.IRQ_QUIET = 1 #no irq
#dma_channel0.CTRL_TRIG.CHAIN_TO = 0
dma_channel0.CTRL_TRIG.TREQ_SEL = dma_dev.TREQ_TIMER0
dma_channel0.CTRL_TRIG.RING_SEL = 0 #0 read adresses are wrapped, 1 write adresses are wrapped
# dma_channel0.CTRL_TRIG.RING_SIZE = 4 #4 words
# dma_channel0.CTRL_TRIG.RING_SIZE = 5 #8 words
# dma_channel0.CTRL_TRIG.RING_SIZE = 6 #16 words
dma_channel0.CTRL_TRIG.RING_SIZE = 7 #32 words
dma_channel0.CTRL_TRIG.INCR_READ = True #True: after read the adress is incremented by one
dma_channel0.CTRL_TRIG.INCR_WRITE = True
dma_channel0.CTRL_TRIG.DATA_SIZE = dma_dev.SIZE_WORD #size of each transfer

dma_channel0.CTRL_TRIG.EN = 1 #runs the channel
#dma is copying
print(target_buffer)


